/* $Id: mod_test.c 57 2023-11-24 10:43:14Z nishi $ */
#include <sunhttpd_module.h>

#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>

/* This is a test module. */
const char mod_name[128] = "Test Module";

bool verbose;

void mod_init(bool v){
	verbose = v;
	if(verbose) fprintf(stderr, "TEST-MOD.. %s got loaded\n", mod_name);
}

int mod_request(struct sunhttpd_module_args args){
	char* str = strdup("HTTP/1.1 200 OK\r\nContent-Length: ");
	args.write(str, strlen(str));
	free(str);
	str = malloc(512);
	memset(str, 0, 512);
	sprintf(str, "%lu", strlen(args.path) + 1 + strlen(args.method));
	args.write(str, strlen(str));
	free(str);
	args.write("\r\n\r\n", 4);
	args.write(args.path, strlen(args.path));
	args.write("\n", 1);
	args.write(args.method, strlen(args.method));
	return 0;
}

int mod_ext(char** args){
	int i;
	for(i = 0; args[i] != NULL; i++){
		if(verbose) fprintf(stderr, "TEST-MOD.. External, %s\n", args[i]);
	}
	return 1;
}
