/* $Id: main.c 13 2023-11-21 02:35:26Z nishi $ */
#include <sunhttpd.h>
#include <sunhttpd_config.h>
#include <sunhttpd_server.h>

#include <ls_server.h>

#include <stdio.h>
#include <string.h>
#include <stdbool.h>

bool verbose = false;

int main(int argc, char** argv){
	int i;
	bool loaded = false;
	for(i = 1; i < argc; i++){
		if(strcmp(argv[i], "--version") == 0){
			printf("SUN HTTPd version %s\n", SUNHTTPD_VERSION);
			printf("Prefix: %s\n", _PREFIX);
			printf("Options: %s\n", OPTIONS);
			return 0;
		}else if(strcmp(argv[i], "--verbose") == 0 || strcmp(argv[i], "-v") == 0){
			verbose = true;
		}else{
			if(sunhttpd_load_config(argv[i]) == -1){
				fprintf(stderr, "SUN HTTPd not started\n");
				return 1;
			}
			loaded = true;
		}
	}
	if(verbose){
	}
	if(verbose) fprintf(stderr, "WELCOME... This is SUN HTTPd, version %s, using libserver version %s\n", SUNHTTPD_VERSION, LIBSERVER_VERSION);
	if(verbose) fprintf(stderr, "OPTIONS... Options: %s\n", OPTIONS);
	if(!loaded){
		if(sunhttpd_load_config(_ETC_PREFIX "/sunhttpd.conf") == -1){
			fprintf(stderr, "SUN HTTPd not started\n");
			return 1;
		}
	}
	if(sunhttpd_server() == -1){
		fprintf(stderr, "SUN HTTPd not started\n");
		return 1;
	}
}
