/* $Id: mtknife.c 3 2023-11-21 06:17:47Z nishi $ */
#include <mtknife.h>

#include <stdlib.h>
#include <stddef.h>

size_t mtkstrlen(const char* str){
	size_t result;
	for(result = 0; str[result] != 0; result++);
	return result;
}

void mtkstrcpy(char* dest, const char* src){
	size_t i;
	for(i = 0; src[i] != 0; i++) dest[i] = src[i];
	dest[i] = 0;
}

char* mtkstrdup(const char* str){
	char* result = malloc(mtkstrlen(str) + 1);
	mtkstrcpy(result, str);
	return result;
}

char* mtkstrcat(const char* str1, const char* str2){
	char* result = malloc(mtkstrlen(str1) + mtkstrlen(str2) + 1);
	mtkstrcpy(result, str1);
	mtkstrcpy(result + mtkstrlen(str1), str2);
	result[mtkstrlen(str1) + mtkstrlen(str2)] = 0;
	return result;
}

char* mtkstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = mtkstrcat(str1, str2);
	char* result = mtkstrcat(tmp, str3);
	free(tmp);
	return result;
}

static void** mqueues = NULL;
size_t mqueue_size = 0;

void* mtkmqueue(void* ptr){
	if(mqueues == NULL){
		mqueue_size = 0;
		mqueues = malloc(sizeof(*mqueues));
		mqueues[0] = NULL;
	}
	mqueues = realloc(mqueues, sizeof(*mqueues) * (mqueue_size + 2));
	mqueues[mqueue_size] = ptr;
	mqueues[mqueue_size + 1] = NULL;
	mqueue_size++;
	return ptr;
}

void mtkmqueue_free(){
	if(mqueues == NULL) return;
	size_t i;
	for(i = 0; mqueues[i] != NULL; i++){
		free(mqueues[i]);
	}
	free(mqueues);
	mqueues = NULL;
	mqueue_size = 0;
}
