/* $Id: test4.c 1 2023-03-13 04:40:25Z nishi $ */
/* Test to check if the mtkmqueue/mtkmqueue_free is working */
#include <mtknife.h>

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <signal.h>

int main(){
	char* str1 = mtkstrdup("Hello");
	char* str2 = mtkstrdup("World");
	char* str3 = mtkstrdup("Test");
	char* buf;
	const char* result;
	buf = mtkmqueue(str1);
	result = strcmp(str1, "Hello") == 0 ? " == Hello" : " != Hello";
	fprintf(stderr, "str1: %s%s\n", buf, result);
	if(buf[1] == '!'){
		fprintf(stderr, "Exiting.\n");
		return 1;
	}
	buf = mtkmqueue(str2);
	result = strcmp(str2, "World") == 0 ? " == World" : " != World";
	fprintf(stderr, "str2: %s%s\n", buf, result);
	if(buf[1] == '!'){
		fprintf(stderr, "Exiting.\n");
		return 1;
	}
	buf = mtkmqueue(str3);
	result = strcmp(str3, "Test") == 0 ? " == Test" : " != Test";
	fprintf(stderr, "str3: %s%s\n", buf, result);
	if(buf[1] == '!'){
		fprintf(stderr, "Exiting.\n");
		return 1;
	}
	mtkmqueue_free();
	pid_t pid = fork();
	if(pid == 0){
		fprintf("%s\n", str1);
		_exit(0);
	}else{
		int status;
		waitpid(pid, &status, 0);
		if(WIFSIGNALED(status)){
			if(WTERMSIG(status) != SIGSEGV){
				fprintf(stderr, "str1 was not freed correctly!\n");
				return 1;
			}else{
				fprintf(stderr, "str1 is freed!\n");
			}
		}else{
			fprintf(stderr, "str1 was not freed correctly!\n");
			return 1;
		}
	}
	pid = fork();
	if(pid == 0){
		fprintf("%s\n", str2);
		_exit(0);
	}else{
		int status;
		waitpid(pid, &status, 0);
		if(WIFSIGNALED(status)){
			if(WTERMSIG(status) != SIGSEGV){
				fprintf(stderr, "str2 was not freed correctly!\n");
				return 1;
			}else{
				fprintf(stderr, "str2 is freed!\n");
			}
		}else{
			fprintf(stderr, "str2 was not freed correctly!\n");
			return 1;
		}
	}
	pid = fork();
	if(pid == 0){
		fprintf("%s\n", str3);
		_exit(0);
	}else{
		int status;
		waitpid(pid, &status, 0);
		if(WIFSIGNALED(status)){
			if(WTERMSIG(status) != SIGSEGV){
				fprintf(stderr, "str3 was not freed correctly!\n");
				return 1;
			}else{
				fprintf(stderr, "str3 is freed!\n");
			}
		}else{
			fprintf(stderr, "str3 was not freed correctly!\n");
			return 1;
		}
	}
	return 0;
}
